#define F_CPU 8000000UL

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "lcd.h"
#include "pff.h"
#include "diskio.h"
#include "integer.h"

#define MOSI 3
#define MISO 4
#define SCK 5
#define SS 2
//----------------------------------------
//char buffer[512] ="Sel...";
char buffer2[512]={};//   
//----------------------------------------
void port_ini(void)
{
 	PORTD=0x00;
 	DDRD=0xFF;
 	PORTB|=(1<<SS)|(1<<MISO)|(1<<MOSI);
 	DDRB|=(1<<SS)|(1<<MOSI)|(1<<SCK);
}
//----------------------------------------
int main(void)
{
	FATFS fs; //  
	FRESULT res; // 
	WORD s1;
	
	port_ini(); // 
	LCD_ini();  // 
	clearlcd();// 
	setpos(0,0);
	str_lcd("Mount SD... ");
	res=pf_mount(&fs);
    if(res==FR_OK) str_lcd("Done");
    else str_lcd("Error");
    _delay_ms(1000);
    setpos(0,3);
    str_lcd("Open file... ");
	res=pf_open("1.txt"); //   1.txt
    if(res==FR_OK) str_lcd("Done");
    else sendcharlcd(res+0x30);
    _delay_ms(1000);
    setpos(0,2);
    str_lcd("Move pointer... ");
	res=pf_lseek(0); //    0  1.txt
    if(res==FR_OK) str_lcd("Done");
    else str_lcd("Error");
    _delay_ms(1000);
    setpos(0,3);
    str_lcd("Read file... ");
	res=pf_read(buffer2,128,&s1);
    if(res==FR_OK) str_lcd("Done");
    else str_lcd("Error");
    _delay_ms(1000);
    clearlcd();// 
    setpos(0,0);
    str_lcd(buffer2);
    _delay_ms(1000);
    setpos(0,4);
    str_lcd("Unmout SD... ");
    res=pf_mount(0x00);//   
    if(res==FR_OK) str_lcd("Done");
    else str_lcd("Error");
/*
    _delay_ms(1000);
    setpos(0,2);
    str_lcd("Mount SD... ");
    res=pf_mount(&fs);
    if(res==FR_OK) str_lcd("Done");
    else str_lcd("Error");
    _delay_ms(1000);
    setpos(0,3);
    str_lcd("Open file... ");
    res=pf_open("/123.txt"); //   123.txt,     
    if(res==FR_OK) str_lcd("Done");
    else str_lcd("Error");
    _delay_ms(2000);
    sprintf(buffer2,"World Hello!");
    clearlcd();// 
    setpos(0,0);
    str_lcd("Write data... ");
    res=pf_write(buffer2,strlen(buffer2),&s1);//   buffer2   123.txt
    if(res==FR_OK) str_lcd("Done");
    else str_lcd("Error");
    _delay_ms(1000);
    setpos(0,1);
    str_lcd("Finalise... ");
    res=pf_write(0,0,&s1);//  123.txt
    if(res==FR_OK) str_lcd("Done");
    else str_lcd("Error");
    _delay_ms(1000);
    setpos(0,2);
    str_lcd("Unmout SD... ");
    res=pf_mount(0x00);//   
    if(res==FR_OK) str_lcd("Done");
    else str_lcd("Error");
    _delay_ms(1000);
    setpos(0,3);
    str_lcd("Mount SD... ");
    res=pf_mount(&fs);
    if(res==FR_OK) str_lcd("Done");
    else str_lcd("Error");
    _delay_ms(2000);
    clearlcd();// 
    setpos(0,0);
    str_lcd("Open file... ");
    res=pf_open("/123.txt"); //   123.txt
    if(res==FR_OK) str_lcd("Done");
    else str_lcd("Error");
    _delay_ms(1000);
    setpos(0,1);
    str_lcd("Move pointer... ");
    res=pf_lseek(0); //    0  123.txt
    if(res==FR_OK) str_lcd("Done");
    else str_lcd("Error");
    _delay_ms(1000);
    setpos(0,2);
    str_lcd("Read file... ");
    res=pf_read(buffer2,128,&s1);
    if(res==FR_OK) str_lcd("Done");
    else str_lcd("Error");
    _delay_ms(1000);
    setpos(0,3);
    str_lcd(buffer2);
    _delay_ms(3000);
    clearlcd();// 
    setpos(0,0);
    str_lcd("Unmout SD... ");
    res=pf_mount(0x00);//   
    if(res==FR_OK) str_lcd("Done");
    else str_lcd("Error");
*/
    while(1)
	{
	}
}
